import { Complex } from './type.js'

export const equal =
   <T>(dep: {
      equal: (a: T, b: T) => boolean
   }) =>
      (w: Complex<T>, z: Complex<T>): boolean => dep.equal(w.re, z.re) && dep.equal(w.im, z.im)
